﻿{
   function myScript(thisObj){
      function myScript_buildUI(thisObj){
         var myPanel = (thisObj instanceof Panel) ? thisObj : new Window("palette", "Isometric Rigger", undefined, {resizeable:true});
         var res = "Group { alignment:['fill','fill'], orientation:'row',\
            rigButton: Button {alignment: ['fill','center'],  text:'Rig', preferredSize:[100,32]} \
         }";
         myPanel.grp = myPanel.add(res);
         
         var defaultImage = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00 \x00\x00\x00 \b\x03\x00\x00\x00D\u00A4\u008A\u00C6\x00\x00\x00BPLTE\x00\x00\x00\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\u00FF\b_\u00D2\u0086\x00\x00\x00\x16tRNS\x00pM(O\x03%E\x19\b61,;\x1F\x14d\\Y>\x12\x1Be\x048Q\x00\x00\x00\u0096IDAT8\u00CB\u00D5\u00D1m\x0E\u0083 \f\u0080\u00E1\u00D2\u00CA7(\u009B\u00EE\u00FEW\u00DD0\u0084v\u00F6\x02\u00FA\u00FCj\u00D27J\x00\u00EE$\u00AEkT3\u00B3\u0081~\u0082\u0095\u00B3\\o\u008ENn\u00B3b\u00E6\u00A4\u00D2\u00E4\u009C\u0098g`^\u0089\u0094\u00E2\u0091\x03c\u0096|YWD\x11t\u00BE\u0088}BT\u0081i;\r\u00D9\u00A3\n\u00BAq\u00942\u00D6:8\u008F\u00D2\x7F\u00AE\x024\fY\u0086)\u00BC\u00F9\x1B8\u00D4\x03$j\u00FF\u0081\u00FF\u00C0\u0085M2p\x164\x19\x00<5h\x1Cx\u00B5\u00E4\u009BX\u00F8\x16\u00B4\u0088=\u00C8\x114~\u0094\u00FD\u0080\u00DB\u00F9\x02\u00F5\u00F6\x05\u00C0\u00B6v\x0F_\x00\x00\x00\x00IEND\u00AEB`\u0082";
         
         var iconButton = myPanel.grp.add ("iconbutton", undefined, ScriptUI.newImage(defaultImage), {style: "toolbutton"});
         iconButton.preferredSize = [40,40];
         iconButton.alignment = ['right','center'];
         iconButton.enabled = false;
         
         myPanel.grp.rigButton.onClick = function() {
            var currentProject = app.project;
            var currentComp = currentProject.activeItem;
            
            if(!currentComp){
                alert("Select a layer in a composition first!");
                return;
            }
            
            var selectedLayers = currentComp.selectedLayers;
            if(selectedLayers.length == 0){
                alert("No layers selected");
                return;
            }
        
            var axesNames = ["X","Y","Z"];
            var expression = 'pos = transform.position;x = effect("X Movement")(1);z = effect("Z Movement")(1);y = effect("Y Movement")(1);[x*Math.sqrt(3) + z*Math.sqrt(3) + pos[0], -x + z + y + pos[1]];';           
            
            app.beginUndoGroup("Create isometric rig");
            for(var i = 0; i < selectedLayers.length; i++){
                var selectedLayer = selectedLayers[i];
                for(var j = 0; j < 3; j++){
                    var slider = selectedLayer.Effects.addProperty("ADBE Slider Control");
                    slider.name = axesNames[j] + " Movement";
                }                
                selectedLayer.property("Position").expression = expression;
            }
            app.endUndoGroup();
         }
      

         myPanel.onResizing =myPanel.onResize = function () { this.layout.resize(); };
              
         myPanel.layout.layout(true);

         return myPanel;
      }
   
      var myScriptPal = myScript_buildUI(thisObj);

      if (myScriptPal != null && myScriptPal instanceof Window){
         myScriptPal.center();
         myScriptPal.show();
      }

   }
   myScript(this);
}